Index: c/src/exec/sapi/headers/confdefs.h
===================================================================
--- c/src/exec/sapi/headers/confdefs.h	(revision 347e40d61d7aae00c3b03d1d05e1c65c172d2b2a)
+++ c/src/exec/sapi/headers/confdefs.h	(revision 31bce9b765155ab5a71a8629261f5c19118689d7)
@@ -306,5 +306,5 @@
 #ifdef CONFIGURE_INIT
 #ifdef STACK_CHECKER_ON
-#include <stackchk.h>
+#include <rtems/stackchk.h>
 #endif
 
Index: c/src/exec/sapi/include/confdefs.h
===================================================================
--- c/src/exec/sapi/include/confdefs.h	(revision 347e40d61d7aae00c3b03d1d05e1c65c172d2b2a)
+++ c/src/exec/sapi/include/confdefs.h	(revision 31bce9b765155ab5a71a8629261f5c19118689d7)
@@ -306,5 +306,5 @@
 #ifdef CONFIGURE_INIT
 #ifdef STACK_CHECKER_ON
-#include <stackchk.h>
+#include <rtems/stackchk.h>
 #endif
 
Index: c/src/lib/libmisc/cpuuse/Makefile.in
===================================================================
--- c/src/lib/libmisc/cpuuse/Makefile.in	(revision 347e40d61d7aae00c3b03d1d05e1c65c172d2b2a)
+++ c/src/lib/libmisc/cpuuse/Makefile.in	(revision 31bce9b765155ab5a71a8629261f5c19118689d7)
@@ -47,8 +47,9 @@
 CLOBBER_ADDITIONS +=
 
-${LIB}: ${SRCS} ${OBJS}
+${LIB}: ${SRCS} preinstall ${OBJS}
 	$(make-library)
 
-all: ${ARCH} $(SRCS) $(LIB)
-	$(INSTALL) -m 444 ${INSTALLED_H_FILES} $(PROJECT_INCLUDE)
-#	$(INSTALL) -m 444 ${H_FILES} $(PROJECT_INCLUDE)/rtems
+all: ${ARCH} $(SRCS) preinstall $(LIB)
+
+preinstall:
+	$(INSTALL) -m 444 ${INSTALLED_H_FILES} $(PROJECT_INCLUDE)/rtems
Index: c/src/lib/libmisc/rtmonuse/Makefile.in
===================================================================
--- c/src/lib/libmisc/rtmonuse/Makefile.in	(revision 347e40d61d7aae00c3b03d1d05e1c65c172d2b2a)
+++ c/src/lib/libmisc/rtmonuse/Makefile.in	(revision 31bce9b765155ab5a71a8629261f5c19118689d7)
@@ -47,7 +47,9 @@
 CLOBBER_ADDITIONS +=
 
-${LIB}: ${SRCS} ${OBJS}
+${LIB}: ${SRCS} preinstall ${OBJS}
 	$(make-library)
 
-all: ${ARCH} $(SRCS) $(LIB)
+all: ${ARCH} $(SRCS) preinstall $(LIB)
+
+preinstall:
 	$(INSTALL) -m 444 ${INSTALLED_H_FILES} $(PROJECT_INCLUDE)/rtems
Index: c/src/lib/libmisc/stackchk/Makefile.in
===================================================================
--- c/src/lib/libmisc/stackchk/Makefile.in	(revision 347e40d61d7aae00c3b03d1d05e1c65c172d2b2a)
+++ c/src/lib/libmisc/stackchk/Makefile.in	(revision 31bce9b765155ab5a71a8629261f5c19118689d7)
@@ -47,7 +47,9 @@
 CLOBBER_ADDITIONS +=
 
-${LIB}: ${SRCS} ${OBJS}
+${LIB}: ${SRCS} preinstall ${OBJS}
 	$(make-library)
 
 all:	${ARCH} $(SRCS) $(LIB)
+
+preinstall:
 	 $(INSTALL) -m 444 ${INSTALLED_H_FILES} $(PROJECT_INCLUDE)/rtems
Index: c/src/libmisc/cpuuse/Makefile.in
===================================================================
--- c/src/libmisc/cpuuse/Makefile.in	(revision 347e40d61d7aae00c3b03d1d05e1c65c172d2b2a)
+++ c/src/libmisc/cpuuse/Makefile.in	(revision 31bce9b765155ab5a71a8629261f5c19118689d7)
@@ -47,8 +47,9 @@
 CLOBBER_ADDITIONS +=
 
-${LIB}: ${SRCS} ${OBJS}
+${LIB}: ${SRCS} preinstall ${OBJS}
 	$(make-library)
 
-all: ${ARCH} $(SRCS) $(LIB)
-	$(INSTALL) -m 444 ${INSTALLED_H_FILES} $(PROJECT_INCLUDE)
-#	$(INSTALL) -m 444 ${H_FILES} $(PROJECT_INCLUDE)/rtems
+all: ${ARCH} $(SRCS) preinstall $(LIB)
+
+preinstall:
+	$(INSTALL) -m 444 ${INSTALLED_H_FILES} $(PROJECT_INCLUDE)/rtems
Index: c/src/libmisc/rtmonuse/Makefile.in
===================================================================
--- c/src/libmisc/rtmonuse/Makefile.in	(revision 347e40d61d7aae00c3b03d1d05e1c65c172d2b2a)
+++ c/src/libmisc/rtmonuse/Makefile.in	(revision 31bce9b765155ab5a71a8629261f5c19118689d7)
@@ -47,7 +47,9 @@
 CLOBBER_ADDITIONS +=
 
-${LIB}: ${SRCS} ${OBJS}
+${LIB}: ${SRCS} preinstall ${OBJS}
 	$(make-library)
 
-all: ${ARCH} $(SRCS) $(LIB)
+all: ${ARCH} $(SRCS) preinstall $(LIB)
+
+preinstall:
 	$(INSTALL) -m 444 ${INSTALLED_H_FILES} $(PROJECT_INCLUDE)/rtems
Index: c/src/libmisc/stackchk/Makefile.in
===================================================================
--- c/src/libmisc/stackchk/Makefile.in	(revision 347e40d61d7aae00c3b03d1d05e1c65c172d2b2a)
+++ c/src/libmisc/stackchk/Makefile.in	(revision 31bce9b765155ab5a71a8629261f5c19118689d7)
@@ -47,7 +47,9 @@
 CLOBBER_ADDITIONS +=
 
-${LIB}: ${SRCS} ${OBJS}
+${LIB}: ${SRCS} preinstall ${OBJS}
 	$(make-library)
 
 all:	${ARCH} $(SRCS) $(LIB)
+
+preinstall:
 	 $(INSTALL) -m 444 ${INSTALLED_H_FILES} $(PROJECT_INCLUDE)/rtems
Index: cpukit/sapi/include/confdefs.h
===================================================================
--- cpukit/sapi/include/confdefs.h	(revision 347e40d61d7aae00c3b03d1d05e1c65c172d2b2a)
+++ cpukit/sapi/include/confdefs.h	(revision 31bce9b765155ab5a71a8629261f5c19118689d7)
@@ -306,5 +306,5 @@
 #ifdef CONFIGURE_INIT
 #ifdef STACK_CHECKER_ON
-#include <stackchk.h>
+#include <rtems/stackchk.h>
 #endif
 