Index: c/src/tests/itrontests/ChangeLog
===================================================================
--- c/src/tests/itrontests/ChangeLog	(revision 4cd2df93b5212bdd371b97e073f33aa909a7d29e)
+++ c/src/tests/itrontests/ChangeLog	(revision 34c1b16dfa14c46d13cd2f4c52e08b934638f9cf)
@@ -1,2 +1,15 @@
+2003-08-16	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	Makefile.am: Reflect having moved automake.
+	itronhello/Makefile.am: Reflect having moved automake.
+	itronmbf01/Makefile.am: Reflect having moved automake.
+	itronmbox01/Makefile.am: Reflect having moved automake.
+	itronsem01/Makefile.am: Reflect having moved automake.
+	itrontask01/Makefile.am: Reflect having moved automake.
+	itrontask02/Makefile.am: Reflect having moved automake.
+	itrontask03/Makefile.am: Reflect having moved automake.
+	itrontask04/Makefile.am: Reflect having moved automake.
+	itrontime01/Makefile.am: Reflect having moved automake.
+
 2003-08-11	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
 
Index: c/src/tests/itrontests/Makefile.am
===================================================================
--- c/src/tests/itrontests/Makefile.am	(revision 4cd2df93b5212bdd371b97e073f33aa909a7d29e)
+++ c/src/tests/itrontests/Makefile.am	(revision 34c1b16dfa14c46d13cd2f4c52e08b934638f9cf)
@@ -10,4 +10,4 @@
 EXTRA_DIST = itrontests.am
 
-include $(top_srcdir)/../../../../automake/subdirs.am
-include $(top_srcdir)/../../../../automake/local.am
+include $(top_srcdir)/../automake/subdirs.am
+include $(top_srcdir)/../automake/local.am
Index: c/src/tests/itrontests/itronhello/Makefile.am
===================================================================
--- c/src/tests/itrontests/itronhello/Makefile.am	(revision 4cd2df93b5212bdd371b97e073f33aa909a7d29e)
+++ c/src/tests/itrontests/itronhello/Makefile.am	(revision 34c1b16dfa14c46d13cd2f4c52e08b934638f9cf)
@@ -24,6 +24,6 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
-include $(top_srcdir)/../../../../automake/compile.am
-include $(top_srcdir)/../../../../automake/leaf.am
+include $(top_srcdir)/../automake/compile.am
+include $(top_srcdir)/../automake/leaf.am
 include $(top_srcdir)/itrontests.am
 
@@ -39,3 +39,3 @@
 EXTRA_DIST = $(C_FILES) $(DOCS)
 
-include $(top_srcdir)/../../../../automake/local.am
+include $(top_srcdir)/../automake/local.am
Index: c/src/tests/itrontests/itronmbf01/Makefile.am
===================================================================
--- c/src/tests/itrontests/itronmbf01/Makefile.am	(revision 4cd2df93b5212bdd371b97e073f33aa909a7d29e)
+++ c/src/tests/itrontests/itronmbf01/Makefile.am	(revision 34c1b16dfa14c46d13cd2f4c52e08b934638f9cf)
@@ -24,6 +24,6 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
-include $(top_srcdir)/../../../../automake/compile.am
-include $(top_srcdir)/../../../../automake/leaf.am
+include $(top_srcdir)/../automake/compile.am
+include $(top_srcdir)/../automake/leaf.am
 include $(top_srcdir)/itrontests.am
 
@@ -39,3 +39,3 @@
 EXTRA_DIST = $(C_FILES) $(DOCS)
 
-include $(top_srcdir)/../../../../automake/local.am
+include $(top_srcdir)/../automake/local.am
Index: c/src/tests/itrontests/itronmbox01/Makefile.am
===================================================================
--- c/src/tests/itrontests/itronmbox01/Makefile.am	(revision 4cd2df93b5212bdd371b97e073f33aa909a7d29e)
+++ c/src/tests/itrontests/itronmbox01/Makefile.am	(revision 34c1b16dfa14c46d13cd2f4c52e08b934638f9cf)
@@ -24,6 +24,6 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
-include $(top_srcdir)/../../../../automake/compile.am
-include $(top_srcdir)/../../../../automake/leaf.am
+include $(top_srcdir)/../automake/compile.am
+include $(top_srcdir)/../automake/leaf.am
 include $(top_srcdir)/itrontests.am
 
@@ -39,3 +39,3 @@
 EXTRA_DIST = $(C_FILES) $(DOCS)
 
-include $(top_srcdir)/../../../../automake/local.am
+include $(top_srcdir)/../automake/local.am
Index: c/src/tests/itrontests/itronsem01/Makefile.am
===================================================================
--- c/src/tests/itrontests/itronsem01/Makefile.am	(revision 4cd2df93b5212bdd371b97e073f33aa909a7d29e)
+++ c/src/tests/itrontests/itronsem01/Makefile.am	(revision 34c1b16dfa14c46d13cd2f4c52e08b934638f9cf)
@@ -24,6 +24,6 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
-include $(top_srcdir)/../../../../automake/compile.am
-include $(top_srcdir)/../../../../automake/leaf.am
+include $(top_srcdir)/../automake/compile.am
+include $(top_srcdir)/../automake/leaf.am
 include $(top_srcdir)/itrontests.am
 
@@ -39,3 +39,3 @@
 EXTRA_DIST = $(C_FILES) $(DOCS)
 
-include $(top_srcdir)/../../../../automake/local.am
+include $(top_srcdir)/../automake/local.am
Index: c/src/tests/itrontests/itrontask01/Makefile.am
===================================================================
--- c/src/tests/itrontests/itrontask01/Makefile.am	(revision 4cd2df93b5212bdd371b97e073f33aa909a7d29e)
+++ c/src/tests/itrontests/itrontask01/Makefile.am	(revision 34c1b16dfa14c46d13cd2f4c52e08b934638f9cf)
@@ -24,6 +24,6 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
-include $(top_srcdir)/../../../../automake/compile.am
-include $(top_srcdir)/../../../../automake/leaf.am
+include $(top_srcdir)/../automake/compile.am
+include $(top_srcdir)/../automake/leaf.am
 include $(top_srcdir)/itrontests.am
 
@@ -39,3 +39,3 @@
 EXTRA_DIST = $(C_FILES) $(DOCS)
 
-include $(top_srcdir)/../../../../automake/local.am
+include $(top_srcdir)/../automake/local.am
Index: c/src/tests/itrontests/itrontask02/Makefile.am
===================================================================
--- c/src/tests/itrontests/itrontask02/Makefile.am	(revision 4cd2df93b5212bdd371b97e073f33aa909a7d29e)
+++ c/src/tests/itrontests/itrontask02/Makefile.am	(revision 34c1b16dfa14c46d13cd2f4c52e08b934638f9cf)
@@ -24,6 +24,6 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
-include $(top_srcdir)/../../../../automake/compile.am
-include $(top_srcdir)/../../../../automake/leaf.am
+include $(top_srcdir)/../automake/compile.am
+include $(top_srcdir)/../automake/leaf.am
 include $(top_srcdir)/itrontests.am
 
@@ -39,3 +39,3 @@
 EXTRA_DIST = $(C_FILES) $(DOCS)
 
-include $(top_srcdir)/../../../../automake/local.am
+include $(top_srcdir)/../automake/local.am
Index: c/src/tests/itrontests/itrontask03/Makefile.am
===================================================================
--- c/src/tests/itrontests/itrontask03/Makefile.am	(revision 4cd2df93b5212bdd371b97e073f33aa909a7d29e)
+++ c/src/tests/itrontests/itrontask03/Makefile.am	(revision 34c1b16dfa14c46d13cd2f4c52e08b934638f9cf)
@@ -24,6 +24,6 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
-include $(top_srcdir)/../../../../automake/compile.am
-include $(top_srcdir)/../../../../automake/leaf.am
+include $(top_srcdir)/../automake/compile.am
+include $(top_srcdir)/../automake/leaf.am
 include $(top_srcdir)/itrontests.am
 
@@ -39,3 +39,3 @@
 EXTRA_DIST = $(C_FILES) $(DOCS)
 
-include $(top_srcdir)/../../../../automake/local.am
+include $(top_srcdir)/../automake/local.am
Index: c/src/tests/itrontests/itrontask04/Makefile.am
===================================================================
--- c/src/tests/itrontests/itrontask04/Makefile.am	(revision 4cd2df93b5212bdd371b97e073f33aa909a7d29e)
+++ c/src/tests/itrontests/itrontask04/Makefile.am	(revision 34c1b16dfa14c46d13cd2f4c52e08b934638f9cf)
@@ -24,6 +24,6 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
-include $(top_srcdir)/../../../../automake/compile.am
-include $(top_srcdir)/../../../../automake/leaf.am
+include $(top_srcdir)/../automake/compile.am
+include $(top_srcdir)/../automake/leaf.am
 include $(top_srcdir)/itrontests.am
 
@@ -39,3 +39,3 @@
 EXTRA_DIST = $(C_FILES) $(DOCS)
 
-include $(top_srcdir)/../../../../automake/local.am
+include $(top_srcdir)/../automake/local.am
Index: c/src/tests/itrontests/itrontime01/Makefile.am
===================================================================
--- c/src/tests/itrontests/itrontime01/Makefile.am	(revision 4cd2df93b5212bdd371b97e073f33aa909a7d29e)
+++ c/src/tests/itrontests/itrontime01/Makefile.am	(revision 34c1b16dfa14c46d13cd2f4c52e08b934638f9cf)
@@ -24,6 +24,6 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
-include $(top_srcdir)/../../../../automake/compile.am
-include $(top_srcdir)/../../../../automake/leaf.am
+include $(top_srcdir)/../automake/compile.am
+include $(top_srcdir)/../automake/leaf.am
 include $(top_srcdir)/itrontests.am
 
@@ -39,3 +39,3 @@
 EXTRA_DIST = $(C_FILES) $(DOCS)
 
-include $(top_srcdir)/../../../../automake/local.am
+include $(top_srcdir)/../automake/local.am
Index: testsuites/itrontests/ChangeLog
===================================================================
--- testsuites/itrontests/ChangeLog	(revision 4cd2df93b5212bdd371b97e073f33aa909a7d29e)
+++ testsuites/itrontests/ChangeLog	(revision 34c1b16dfa14c46d13cd2f4c52e08b934638f9cf)
@@ -1,2 +1,15 @@
+2003-08-16	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	Makefile.am: Reflect having moved automake.
+	itronhello/Makefile.am: Reflect having moved automake.
+	itronmbf01/Makefile.am: Reflect having moved automake.
+	itronmbox01/Makefile.am: Reflect having moved automake.
+	itronsem01/Makefile.am: Reflect having moved automake.
+	itrontask01/Makefile.am: Reflect having moved automake.
+	itrontask02/Makefile.am: Reflect having moved automake.
+	itrontask03/Makefile.am: Reflect having moved automake.
+	itrontask04/Makefile.am: Reflect having moved automake.
+	itrontime01/Makefile.am: Reflect having moved automake.
+
 2003-08-11	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
 
Index: testsuites/itrontests/Makefile.am
===================================================================
--- testsuites/itrontests/Makefile.am	(revision 4cd2df93b5212bdd371b97e073f33aa909a7d29e)
+++ testsuites/itrontests/Makefile.am	(revision 34c1b16dfa14c46d13cd2f4c52e08b934638f9cf)
@@ -10,4 +10,4 @@
 EXTRA_DIST = itrontests.am
 
-include $(top_srcdir)/../../../../automake/subdirs.am
-include $(top_srcdir)/../../../../automake/local.am
+include $(top_srcdir)/../automake/subdirs.am
+include $(top_srcdir)/../automake/local.am
Index: testsuites/itrontests/itronhello/Makefile.am
===================================================================
--- testsuites/itrontests/itronhello/Makefile.am	(revision 4cd2df93b5212bdd371b97e073f33aa909a7d29e)
+++ testsuites/itrontests/itronhello/Makefile.am	(revision 34c1b16dfa14c46d13cd2f4c52e08b934638f9cf)
@@ -24,6 +24,6 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
-include $(top_srcdir)/../../../../automake/compile.am
-include $(top_srcdir)/../../../../automake/leaf.am
+include $(top_srcdir)/../automake/compile.am
+include $(top_srcdir)/../automake/leaf.am
 include $(top_srcdir)/itrontests.am
 
@@ -39,3 +39,3 @@
 EXTRA_DIST = $(C_FILES) $(DOCS)
 
-include $(top_srcdir)/../../../../automake/local.am
+include $(top_srcdir)/../automake/local.am
Index: testsuites/itrontests/itronmbf01/Makefile.am
===================================================================
--- testsuites/itrontests/itronmbf01/Makefile.am	(revision 4cd2df93b5212bdd371b97e073f33aa909a7d29e)
+++ testsuites/itrontests/itronmbf01/Makefile.am	(revision 34c1b16dfa14c46d13cd2f4c52e08b934638f9cf)
@@ -24,6 +24,6 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
-include $(top_srcdir)/../../../../automake/compile.am
-include $(top_srcdir)/../../../../automake/leaf.am
+include $(top_srcdir)/../automake/compile.am
+include $(top_srcdir)/../automake/leaf.am
 include $(top_srcdir)/itrontests.am
 
@@ -39,3 +39,3 @@
 EXTRA_DIST = $(C_FILES) $(DOCS)
 
-include $(top_srcdir)/../../../../automake/local.am
+include $(top_srcdir)/../automake/local.am
Index: testsuites/itrontests/itronmbox01/Makefile.am
===================================================================
--- testsuites/itrontests/itronmbox01/Makefile.am	(revision 4cd2df93b5212bdd371b97e073f33aa909a7d29e)
+++ testsuites/itrontests/itronmbox01/Makefile.am	(revision 34c1b16dfa14c46d13cd2f4c52e08b934638f9cf)
@@ -24,6 +24,6 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
-include $(top_srcdir)/../../../../automake/compile.am
-include $(top_srcdir)/../../../../automake/leaf.am
+include $(top_srcdir)/../automake/compile.am
+include $(top_srcdir)/../automake/leaf.am
 include $(top_srcdir)/itrontests.am
 
@@ -39,3 +39,3 @@
 EXTRA_DIST = $(C_FILES) $(DOCS)
 
-include $(top_srcdir)/../../../../automake/local.am
+include $(top_srcdir)/../automake/local.am
Index: testsuites/itrontests/itronsem01/Makefile.am
===================================================================
--- testsuites/itrontests/itronsem01/Makefile.am	(revision 4cd2df93b5212bdd371b97e073f33aa909a7d29e)
+++ testsuites/itrontests/itronsem01/Makefile.am	(revision 34c1b16dfa14c46d13cd2f4c52e08b934638f9cf)
@@ -24,6 +24,6 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
-include $(top_srcdir)/../../../../automake/compile.am
-include $(top_srcdir)/../../../../automake/leaf.am
+include $(top_srcdir)/../automake/compile.am
+include $(top_srcdir)/../automake/leaf.am
 include $(top_srcdir)/itrontests.am
 
@@ -39,3 +39,3 @@
 EXTRA_DIST = $(C_FILES) $(DOCS)
 
-include $(top_srcdir)/../../../../automake/local.am
+include $(top_srcdir)/../automake/local.am
Index: testsuites/itrontests/itrontask01/Makefile.am
===================================================================
--- testsuites/itrontests/itrontask01/Makefile.am	(revision 4cd2df93b5212bdd371b97e073f33aa909a7d29e)
+++ testsuites/itrontests/itrontask01/Makefile.am	(revision 34c1b16dfa14c46d13cd2f4c52e08b934638f9cf)
@@ -24,6 +24,6 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
-include $(top_srcdir)/../../../../automake/compile.am
-include $(top_srcdir)/../../../../automake/leaf.am
+include $(top_srcdir)/../automake/compile.am
+include $(top_srcdir)/../automake/leaf.am
 include $(top_srcdir)/itrontests.am
 
@@ -39,3 +39,3 @@
 EXTRA_DIST = $(C_FILES) $(DOCS)
 
-include $(top_srcdir)/../../../../automake/local.am
+include $(top_srcdir)/../automake/local.am
Index: testsuites/itrontests/itrontask02/Makefile.am
===================================================================
--- testsuites/itrontests/itrontask02/Makefile.am	(revision 4cd2df93b5212bdd371b97e073f33aa909a7d29e)
+++ testsuites/itrontests/itrontask02/Makefile.am	(revision 34c1b16dfa14c46d13cd2f4c52e08b934638f9cf)
@@ -24,6 +24,6 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
-include $(top_srcdir)/../../../../automake/compile.am
-include $(top_srcdir)/../../../../automake/leaf.am
+include $(top_srcdir)/../automake/compile.am
+include $(top_srcdir)/../automake/leaf.am
 include $(top_srcdir)/itrontests.am
 
@@ -39,3 +39,3 @@
 EXTRA_DIST = $(C_FILES) $(DOCS)
 
-include $(top_srcdir)/../../../../automake/local.am
+include $(top_srcdir)/../automake/local.am
Index: testsuites/itrontests/itrontask03/Makefile.am
===================================================================
--- testsuites/itrontests/itrontask03/Makefile.am	(revision 4cd2df93b5212bdd371b97e073f33aa909a7d29e)
+++ testsuites/itrontests/itrontask03/Makefile.am	(revision 34c1b16dfa14c46d13cd2f4c52e08b934638f9cf)
@@ -24,6 +24,6 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
-include $(top_srcdir)/../../../../automake/compile.am
-include $(top_srcdir)/../../../../automake/leaf.am
+include $(top_srcdir)/../automake/compile.am
+include $(top_srcdir)/../automake/leaf.am
 include $(top_srcdir)/itrontests.am
 
@@ -39,3 +39,3 @@
 EXTRA_DIST = $(C_FILES) $(DOCS)
 
-include $(top_srcdir)/../../../../automake/local.am
+include $(top_srcdir)/../automake/local.am
Index: testsuites/itrontests/itrontask04/Makefile.am
===================================================================
--- testsuites/itrontests/itrontask04/Makefile.am	(revision 4cd2df93b5212bdd371b97e073f33aa909a7d29e)
+++ testsuites/itrontests/itrontask04/Makefile.am	(revision 34c1b16dfa14c46d13cd2f4c52e08b934638f9cf)
@@ -24,6 +24,6 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
-include $(top_srcdir)/../../../../automake/compile.am
-include $(top_srcdir)/../../../../automake/leaf.am
+include $(top_srcdir)/../automake/compile.am
+include $(top_srcdir)/../automake/leaf.am
 include $(top_srcdir)/itrontests.am
 
@@ -39,3 +39,3 @@
 EXTRA_DIST = $(C_FILES) $(DOCS)
 
-include $(top_srcdir)/../../../../automake/local.am
+include $(top_srcdir)/../automake/local.am
Index: testsuites/itrontests/itrontime01/Makefile.am
===================================================================
--- testsuites/itrontests/itrontime01/Makefile.am	(revision 4cd2df93b5212bdd371b97e073f33aa909a7d29e)
+++ testsuites/itrontests/itrontime01/Makefile.am	(revision 34c1b16dfa14c46d13cd2f4c52e08b934638f9cf)
@@ -24,6 +24,6 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
-include $(top_srcdir)/../../../../automake/compile.am
-include $(top_srcdir)/../../../../automake/leaf.am
+include $(top_srcdir)/../automake/compile.am
+include $(top_srcdir)/../automake/leaf.am
 include $(top_srcdir)/itrontests.am
 
@@ -39,3 +39,3 @@
 EXTRA_DIST = $(C_FILES) $(DOCS)
 
-include $(top_srcdir)/../../../../automake/local.am
+include $(top_srcdir)/../automake/local.am